JbossDeploymentTool (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.ejb, class: JbossDeploymentTool

# Class JbossDeploymentTool

java.lang.Object
org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool
org.apache.tools.ant.taskdefs.optional.ejb.JbossDeploymentTool

All Implemented Interfaces:
  `EJBDeploymentTool`

public class JbossDeploymentTool extends GenericDeploymentTool
The deployment tool to add the jboss specific deployment descriptor to the ejb jar file. Jboss only requires one additional file jboss.xml and does not require any additional compilation.

Version:
  1.0
See Also:
  - `EjbJar.createJboss()`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `JBOSS_CMP10D`
  `protected static final String`
  `JBOSS_CMP20D`
  `protected static final String`
  `JBOSS_DD`

  ### Fields inherited from class GenericDeploymentTool

  `ANALYZER_CLASS_FULL, ANALYZER_CLASS_SUPER, ANALYZER_FULL, ANALYZER_NONE, ANALYZER_SUPER, DEFAULT_ANALYZER, DEFAULT_BUFFER_SIZE, EJB_DD, JAR_COMPRESS_LEVEL, MANIFEST, META_DIR`
  Modifier and Type
  Field
  Description
  `static final String`
  `ANALYZER_CLASS_FULL`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_CLASS_SUPER`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_FULL`
  A dependency analyzer name to find all related classes
  `static final String`
  `ANALYZER_NONE`
  A dependency analyzer name for no analyzer
  `static final String`
  `ANALYZER_SUPER`
  A dependency analyzer name to find ancestor classes
  `static final String`
  `DEFAULT_ANALYZER`
  The default analyzer
  `static final int`
  `DEFAULT_BUFFER_SIZE`
  The default buffer byte size to use for IO
  `protected static final String`
  `EJB_DD`
  Name for EJB Deployment descriptor within EJB jars
  `static final int`
  `JAR_COMPRESS_LEVEL`
  The level to use for compression
  `protected static final String`
  `MANIFEST`
  The standard MANIFEST file
  `protected static final String`
  `META_DIR`
  The standard META-INF directory in jar files

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JbossDeploymentTool()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)`
  Add any vendor specific files which should be included in the EJB Jar.
  `void`
  `setSuffix(String inString)`
  Setter used to store the suffix for the generated JBoss jar file.
  `void`
  `validateConfigured()`
  Called to validate that the tool parameters have been configured.

  ### Methods inherited from class GenericDeploymentTool

  `addFileToJar, addSupportClasses, checkAndAddDependants, checkConfiguration, configure, createClasspath, getClassLoaderForBuild, getCombinedClasspath, getConfig, getDescriptorHandler, getDestDir, getJarBaseName, getLocation, getManifestFile, getPublicId, getTask, getVendorDDPrefix, log, needToRebuild, parseEjbFiles, processDescriptor, registerKnownDTDs, setClasspath, setDestdir, setGenericJarSuffix, setTask, usingBaseJarName, writeJar`
  Modifier and Type
  Method
  Description
  `protected void`
  `addFileToJar(JarOutputStream jStream, File inputFile, String logicalFilename)`
  Utility method that encapsulates the logic of adding a file entry to a .jar file.
  `protected void`
  `addSupportClasses(Hashtable<String,File> ejbFiles)`
  Adds any classes the user specifies using support nested elements to the `ejbFiles` Hashtable.
  `protected void`
  `checkAndAddDependants(Hashtable<String,File> checkEntries)`
  Add all available classes, that depend on Remote, Home, Bean, PK
  `protected void`
  `checkConfiguration(String descriptorFileName, SAXParser saxParser)`
  This method is called as the first step in the processDescriptor method to allow vendor-specific subclasses to validate the task configuration prior to processing the descriptor.
  `void`
  `configure(org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config config)`
  Configure this tool for use in the ejbjar task.
  `Path`
  `createClasspath()`
  Add the classpath for the user classes
  `protected ClassLoader`
  `getClassLoaderForBuild()`
  Returns a Classloader object which parses the passed in generic EjbJar classpath.
  `protected Path`
  `getCombinedClasspath()`
  Get the classpath by combining the one from the surrounding task, if any and the one from this tool.
  `protected org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config`
  `getConfig()`
  Get the basename terminator.
  `protected DescriptorHandler`
  `getDescriptorHandler(File srcDir)`
  Get a descriptionHandler.
  `protected File`
  `getDestDir()`
  Get the destination directory.
  `protected String`
  `getJarBaseName(String descriptorFileName)`
  Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file.
  `protected Location`
  `getLocation()`
  Get the build file location associated with this element's task.
  `protected File`
  `getManifestFile(String prefix)`
  Get the manifest file to use for building the generic jar.
  `protected String`
  `getPublicId()`
  Returns the Public ID of the DTD specified in the EJB descriptor.
  `protected Task`
  `getTask()`
  Get the task for this tool.
  `String`
  `getVendorDDPrefix(String baseName, String descriptorFileName)`
  Get the prefix for vendor deployment descriptors.
  `protected void`
  `log(String message, int level)`
  Log a message to the Ant output.
  `protected boolean`
  `needToRebuild(Hashtable<String,File> ejbFiles, File jarFile)`
  This method checks the timestamp on each file listed in the `ejbFiles` and compares them to the timestamp on the `jarFile` .
  `protected Hashtable<String,File>`
  `parseEjbFiles(String descriptorFileName, SAXParser saxParser)`
  This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
  `void`
  `processDescriptor(String descriptorFileName, SAXParser saxParser)`
  Process a deployment descriptor, generating the necessary vendor specific deployment files.
  `protected void`
  `registerKnownDTDs(DescriptorHandler handler)`
  Register the locations of all known DTDs.
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to be used for this compilation.
  `void`
  `setDestdir(File inDir)`
  Set the destination directory; required.
  `void`
  `setGenericJarSuffix(String inString)`
  Set the suffix for the generated jar file.
  `void`
  `setTask(Task task)`
  Set the task which owns this tool
  `protected boolean`
  `usingBaseJarName()`
  Indicate if this build is using the base jar name.
  `protected void`
  `writeJar(String baseName, File jarfile, Hashtable<String,File> files, String publicId)`
  Method used to encapsulate the writing of the JAR file.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### JBOSS_DD

    protected static final String JBOSS_DD
    See Also:
      - Constant Field Values

  - ### JBOSS_CMP10D

    protected static final String JBOSS_CMP10D
    See Also:
      - Constant Field Values

  - ### JBOSS_CMP20D

    protected static final String JBOSS_CMP20D
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### JbossDeploymentTool

    public JbossDeploymentTool()

- ## Method Details

  - ### setSuffix

    public void setSuffix(String inString)
    Setter used to store the suffix for the generated JBoss jar file.
    Parameters:
      `inString` - the string to use as the suffix.

  - ### addVendorFiles

    protected void addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)
    Add any vendor specific files which should be included in the EJB Jar.
    Overrides:
      `addVendorFiles` in class `GenericDeploymentTool`
    Parameters:
      `ejbFiles` - the hashtable of files to populate.
      `ddPrefix` - the prefix to use.

  - ### validateConfigured

    public void validateConfigured() throws BuildException
    Called to validate that the tool parameters have been configured.
    Specified by:
      `validateConfigured` in interface `EJBDeploymentTool`
    Overrides:
      `validateConfigured` in class `GenericDeploymentTool`
    Throws:
      `BuildException` - If the Deployment Tool's configuration isn't valid
    Since:
      ant 1.6